import greenfoot.*;

/**
 * Class ExpandingText: a class that animates text with sizing and intensity cycling
 */
public class ExpandingText extends Actor
{
    int maxSize, size, dir, speed;
    GreenfootImage image;
    
    /**
     * ExpandingText constructor: sets field values and initializes text image
     *
     * @param text the text to animate
     * @param maxFontSize the maximum font size for the text
     * @param color the color of the text
     * @param rate how fast the animation is to run
     */
    public ExpandingText(String text, int maxFontSize, Color color, int rate)
    {
        size = maxSize = maxFontSize;
        speed = rate;
        image = new GreenfootImage(text, size, color, new Color(0, 0, 0, 0));
        setImage(image);
    }
    
    /**
     * Method act: runs the animation of the displayed text
     */
    public void act()
    {
        if (size >= maxSize) dir = -1;
        if (size <= 32) dir = 1;
        size += dir*speed;
        GreenfootImage img = new GreenfootImage(image);
        img.scale(image.getWidth()*size/maxSize, image.getHeight()*size/maxSize);
        img.setTransparency(75+size*180/maxSize);
        setImage(img);
    }
}